#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "basic_io.h"

// le registro a registro

int main(int argc, char ** argv){

	int i;
	long sum_of_block_ids;
	File * in;
	unsigned char * buffer;

	in = open_for_read(argv[1]);
	buffer = alloc_alligned_buffer(RECORD_SIZE);

	sum_of_block_ids = 0;

	for(i = 0; i < N_RECORDS; i++){

		if(read_bytes(in, buffer, RECORD_SIZE) != RECORD_SIZE){

			printf("erro na leitura!\n");
			return 1;
		}
		
		sum_of_block_ids += ((int *) buffer)[0];
	}

	close_file(in);

	printf("soma = %ld\n", sum_of_block_ids);

	return 0;
}
