#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "basic_io.h"

// leitura registros a registro em ordem aleatória

int main(int argc, char ** argv){

	int i, j, tmp;
	int * ids;
	long sum_of_block_ids;
	File * in;
	unsigned char * buffer;

	in = open_for_read(argv[1]);
	buffer = alloc_alligned_buffer(RECORD_SIZE);
	
	// array de ids	
	ids = (int *) malloc (N_RECORDS * sizeof(int));

	// iniciando array de ids
	for(i = 0; i < N_RECORDS; i++) ids[i] = i;

	// embaralhando array de ids
	for(i = 0; i < N_RECORDS; i++){

		j = random() % N_RECORDS;

		tmp = ids[i];
		ids[i] = ids[j];
		ids[j] = tmp;
	}
	
	sum_of_block_ids = 0;

	for(i = 0; i < N_RECORDS; i++){

		seek(in, ids[i] * RECORD_SIZE);

		if(read_bytes(in, buffer, RECORD_SIZE) != RECORD_SIZE){

			printf("erro na leitura!\n");
			return 1;
		}

		sum_of_block_ids += ((int *)buffer)[0];
	}

	close_file(in);

	printf("soma = %ld\n", sum_of_block_ids);

	return 0;
}
