#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "basic_io.h"

// faz a leitura por blocos

int main(int argc, char ** argv){

	int i, j;
	long sum_of_block_ids;
	File * in;
	unsigned char * buffer;
	unsigned char * record_pointer;

	in = open_for_read(argv[1]);
	buffer = alloc_alligned_buffer(BLOCK_SIZE * MULTI_FACTOR);

	sum_of_block_ids = 0;

	for(i = 0; i < N_BLOCKS / MULTI_FACTOR; i++){

		if(read_bytes(in, buffer, BLOCK_SIZE * MULTI_FACTOR) != BLOCK_SIZE * MULTI_FACTOR){

			printf("erro na leitura!\n");
			return 1;
		}

		for(j = 0; j < RECORDS_PER_BLOCK * MULTI_FACTOR; j++){

			record_pointer = buffer + (j * RECORD_SIZE);
			sum_of_block_ids += ((int *) record_pointer)[0];
		}
	}

	close_file(in);

	printf("soma = %ld\n", sum_of_block_ids);

	return 0;
}
